package itz;
import java.io.*;
import static javax.swing.JOptionPane.*;
public class ProcesaCalifica {
    static double califica[]; //Arreglo para calificaciones
	public static void main(String[] args) {
	       String menu="1..Leer Calificaciones\n" +
	       		"2..Guardar Calificaciones\n" +
	       		"3..Cargar calificaciones\n" +
	       		"4..Calcular Promedio\n" +
	       		"5..Calcular porcentaje de aprobados\n"+
	       		"6..Mostrar Calificaciones\n"+
	            "7..Fin\n";
	       int opc = 0;
	       do {
	    	   try{
	    	   opc=Integer.parseInt(showInputDialog(menu));
	     	   switch (opc){
	    	   case 1:califica=leerCalifica();break;
	    	   case 2:guardarCalifica(califica);break;
	    	   case 3:califica=cargarCalifica();break;
	    	   case 4:showMessageDialog(null,"Promedio="+
	    			   promedio(califica));break;
	    	   case 5:showMessageDialog(null,"Porcentaje"+
	    			   " de aprobados="+aprobados(califica));
	    	           break;
	    	   case 6:mostrarCalifica(califica);break;         
	    	   case 7:break;
	    	   default:
	    		   showMessageDialog(null,"Opcion no valida");
	    	   }
	    	   } catch (Exception ex){
	    		   showMessageDialog(null,"Opcion no valida");
	    	   }
	       } while (opc!=7);
	}
	public static double [] leerCalifica(){
		String valores[]=
		showInputDialog("Teclea las calificaciones " +
				"separadas por coma:").split(",");
		double aux[]=new double[valores.length];
		for (int i=0;i<valores.length;i++)
			aux[i]=Double.parseDouble(valores[i]);
		return aux;	
	}
	public static void guardarCalifica(double califica[]){
		DataOutputStream archivo=null;
		try{
			String na=showInputDialog("Ruta y archivo:");
			archivo=new DataOutputStream(
					      new BufferedOutputStream(
					      new FileOutputStream(na)));
		   for (int i=0;i<califica.length;i++)
			   archivo.writeDouble(califica[i]);
		   archivo.close();
		   showMessageDialog(null,"Archivo creado");	
		} catch (Exception ex){
		     showMessageDialog(null,"Error al guardar archivo");	
		}
	}
	public static double [] cargarCalifica(){
		double aux[] = null;
		DataInputStream archivo=null;
		int n=0;
		try{
			String na=showInputDialog("Ruta y archivo:");
			archivo=new DataInputStream(
					      new BufferedInputStream(
					      new FileInputStream(na)));
			try {
				    //Se calcula el numero de bytes del archivo de datos
				    int nb=archivo.available();
				    //Si un double ocupa 64 bits es decir 8 bytes 
				    //se divide para saber cuantos valores son
				    n=nb/8;
				    aux=new double[n]; //Crea arreglo de acuerdo al numero de bytes del archivo
				    int i=0;
				    while (true){ //recorre el archivo para contar cuantos valores son
						aux[i]=archivo.readDouble();
						i=i+1;
					}
			} catch (EOFException e){
				      archivo.close();
					  showMessageDialog(null,"Archivo cargado");
					  return aux;
				}
		} catch (Exception ex){
			showMessageDialog(null,"Error al abrir archivo");
			return null;
		}
	}	
	public static double promedio(double califica[]){
		double suma=0.0;
		for (int i=0;i<califica.length;i++)
			suma=suma+califica[i];
		return (suma/(double) califica.length);
	}
	public static double aprobados(double califica[]){
		int ca=0;
		for (int i=0;i<califica.length;i++)
			if (califica[i]>=70) ca++;
		return(((double)ca/(double)califica.length)*100);
	}
	public static void mostrarCalifica(double califica[]){
		if (califica!=null) {
		String salida="";
		for (int i=0;i<califica.length;i++)
			salida+=califica[i]+",";
		showMessageDialog(null,salida);
		} else showMessageDialog(null,"No existen datos"); 
	}
}
